class NodeT:
    def __init__(self,value):
        self.data = value
        self.next = None
        
class LinkedListT:
    def __init__(self):
        self.h = None
        
    def createLinkedList(self,valueT):
        n = NodeT(valueT) # creating a node is the first task.data = valueT , next = None
        if self.h is None:
            self.h = n # add this node as the head if there is no head
        else:
            t = self.h # following immutability so that head node is untouched.
            while (t.next !=None):# this is equivalent to saying while (t!=None):
                t=t.next# go to next Node
            t.next = n # finally if t.next == None is found then assign new node 'n' to latest t.next . This means that new node will be added always at the last            
    
    def sizeOfLinkedList(self):
        t = self.h # Now the head Node is assigned to a temporary Node.with this approach head node is not mutated. this is called immutability.
        count = 0
        while(t!=None):
            count+=1
            t = t.next # assign the next node(even if not present as later we compare with null ) to the t
        return count
    
    def displayLinkedList(self):
        t = self.h
        if t==None:
            print("No Data")
            
        while (t!=None):
            print(t.data,end=" ")
            t=t.next
        print()
        
    def displayLLWithGivenHead(self,head):
        t = head
        if t is None:
            print("No Data")
        i = 0
        while t is not None:
            print(f"{i}:{t.data}",end=" > ")
            i+=1
            t = t.next
        print(f"{i}={None}")
        
    
    def insertLinkedList(self,valueT,zerobasedposition):
        nn = NodeT(valueT)
        
        # if insert is at 0
        if (zerobasedposition==0) or (self.h is None):
            nn.next = self.h
            self.h = nn
            return (self.displayLinkedList())
            
        # if insert is at last 
        # if insert at otherwise.suppose 2nd index.0 1 2 3 4 5 > 0 1 [x] 2 3 4 5
        #count = 0
        t = self.h # at 0-th index
        for i in range(1,zerobasedposition):
            if t.next is None:
                break
            t = t.next
        nn.next = t.next
        t.next = nn
        return (self.displayLinkedList())
    
    def insertAltLinkedList(self,valueT,positionT):
        new_node = NodeT(valueT)
        if positionT == 0:
            new_node.next = self.h
            self.h = new_node
        else:
            current = self.h
            prev = None
            count = 0
            while current and count < positionT:
                prev = current
                current = current.next
                count += 1
            prev.next = new_node
            new_node.next = current
            
    def deleteLinkedList(self,zerobasedposition):
        if self.h is None:
            return self.displayLinkedList()
        if zerobasedposition ==0:
            self.h = self.h.next
            return self.displayLinkedList()
        t = self.h
        for i in range(1,zerobasedposition):
            if t.next is None:
                break
            t = t.next
        if self.sizeOfLinkedList()<=zerobasedposition:
            return self.displayLinkedList()
        t.next = t.next.next
        return self.displayLinkedList()
    
    def searchLinkedList(self,valueT):
        t=self.h
        while t:
            if t.data == valueT:
                return True
            t = t.next
        return False
    
    def reverseLinkedList(self):
        t = self.h
        rh = None
        while (self.h):
            # Isolate the Node from start one by one 
            t = t.next # moving t to the next node 
            self.h.next = None # assigning None to head node so that it is disconnected 
            # Updating the self.h node with another node rh
            self.h.next = rh
            # updating rh with head node now 
            rh = self.h
            # moving the self. h to the t node 
            self.h = t
        
        t = rh
        if t==None:
            print("No Data")
            
        while (t!=None):
            print(t.data,end=" ")
            t=t.next
        print()
    
    def middleLinkedList(self):
        k = self.sizeOfLinkedList()
        fc = k//2 + 1
        t = self.h
        for i in range(fc-1):
            t = t.next
        return t.data
    
    def middleOptimalLL(self):# t=n,s=1
        s = self.h
        f = self.h
        if self.h == None:
            return None
        while (f.next != None and f.next.next != None):
            s =s.next
            f = f.next.next
        return s
    ## ACTIONSTEP-1(9) : add the instance1 and instance2 as parameters which will be of type : LinkedList() class
    def find_intersection_node(self,instance1,instance2,flag=0):#flag = 0 means dont break intersection. flag =1 means break the intersection
        found_start = False
        # TODO-1(1): pass the two instances of linked lists - instance1 and instance2 . store it in h1 and h2
        h1 = instance1.h
        h2 = instance2.h
        
        # TODO-2(2): connect the end of h1 to beginning of h2 to create a circle or loop
        ## 2.ACTIONSTEP-1(10): find the end of h1. Note : The logic here is that even if we assume from h2 side stilll the finding of loop end of h2 and then connection to h1 beginning is also valid . So choosing either h1 or h2 as the base doesn't create any issue
        def find_end(head):
            t = head
            while t.next is not None:
                t = t.next
            return t
        
        ## 2.ACTIONSTEP-2(11): connecting the end of head h1 to the beginning of head h2.
        eh1 = find_end(h1)
        eh1.next = h2
        
        # TODO-3(3): if using slow and fast . then create two temporary nodes at h1 with s and f . s will go by one step and f will go by 2 steps 
        ## 3.ACTIONSTEP-1(12-NR): defining the slow and fast temporary node at h1.
        #s= h1
        #f= h1
        ## 3.ACTIONSTEP-2(13): find the meeting node for s and f 
        def find_meeting(head):
            if head is None:
                return None
            s = head
            f = head
            s = s.next
            f = f.next.next
            while (s != f):
                s = s.next
                f = f.next.next
            return s
        m = find_meeting(h1)        
        
        # TODO-4(4): find the node wherever the s and f will meet again.save that node in another temporary node like m = meeting node
        ## 4.ACTIONSTEP-1(14-NA): Done with the previous TODO
        
        # TODO-5(5): create two temporary nodes again. one is s1 starting at h1 and another s2 starting at m node saved in previous step 
        ## 5.ACTIONSTEP-1(15) : traversing the s1 and s2 to find the start node
        def find_start(head,meeting):
            s1=head
            s2=meeting
            while s1!=s2:
                s1=s1.next
                s2=s2.next
            return s1 # or s2 as now they meet.
        start = find_start(h1,m)
        found_start = True
        
        # TODO-6(6): Run the above node till they do not meet again. once they meet then save that as start node . Create another temporary node called last node at the same place .
        ## 6.ACTIONSTEP-1(16-NA): Already completed in previous TODO
        
        # TODO-7(7): Run the last node to traverse till it reaches that its next node is start and then break the link making last.next = null
        ## 7.ACTIONSTEP-1(17): Traversing the last node and breaking the link which will open the linked list in a single long linked list wihtout any loop
        #last = start
        def break_intersection(startnode):
            last = startnode
            last = last.next
            while last.next != startnode:
                last = last.next
            last.next = None
        if flag==1:
            if found_start:
                break_intersection(start)
                
        # TODO-8(8): Return the start node as the intersection node.
        ## 8.ACTIONSTEP-3(18): To note here that this link should be broken again after we find the intersection node so that existing structure of linked list is not broken
        if flag==0 and found_start:
            eh1.next = None
        ## 8.ACTIONSTEP-1(19)
        return start
    
def mergeToSortLL(instance1,instance2):#t=n+m, s= 1
    #h = self.h
    #hd = None
    #t = None
    # here h1 and h2 are Node which are of type class so we need to create an instance here as well 
    h1 = instance1.h
    h2 = instance2.h
    if ( h1 == None ):
        return h2
    if (h2 == None):
        return h1
    if(h1.data < h2.data):
        hd = h1 # assigning to the merged head which we will later return 
        t = h1 # temporary node to keep the previous node in case we are moving from h1 to its next h1
        h1 = h1.next # moving the h1 to its next node 
    else:
        hd = h2 # assigning to the merged head which we will later return 
        t = h2 #temporary node to keep the previous node in case we are moving from h2 to its next h2
        h2 = h2.next # moving the h2 to its next node 
    # we need to traverse through the loop and start arrangingn the new linked list in ascending order 
    # h1 : hd=2 > 3 > 5  > 10 > Null
    # h2 : 4 > 7 > 14 > 20 > 30 > Null
    # lower data will always contain the last 't' if Null found 
    while (h1!= None and h2!=None): # both should be Not Null then only we should continue the loop else stop the loop
        if (h1.data < h2.data):
            t.next = h1
            h1= h1.next
            t = t.next
        else:
            t.next = h2
            h2=h2.next
            t = t.next
    if (h1 == None):
        t.next = h2
    else:
        t.next = h1
    
    instance = LinkedListT()
    instance.displayLLWithGivenHead(hd)
    return hd



def detectCycleLL(self):# using hashset . t=n+n =2n ,s=m
    pass

def detectCycleOptimalLL(self):#using slow and fast
    pass

            
            
# create an instance of Linked list 
ll1 = LinkedListT()
ll2 = LinkedListT()

ll1.createLinkedList(2)
ll1.createLinkedList(3)
ll1.createLinkedList(5)
ll1.createLinkedList(10)

ll2.createLinkedList(4)
ll2.createLinkedList(5)
ll2.createLinkedList(7)
ll2.createLinkedList(20)
ll2.createLinkedList(30)
ll2.createLinkedList(32)

ll1.displayLinkedList()
ll2.displayLinkedList()
print(mergeToSortLL(ll1,ll2))

# append elements to the linked list 
'''
my_list.createLinkedList(10)
my_list.createLinkedList(20)
my_list.createLinkedList(30)
my_list.createLinkedList(80)
my_list.createLinkedList(86)
my_list.createLinkedList(90)
my_list.createLinkedList(99)

# Display the linked list 
print(my_list.h.data)
my_list.displayLinkedList() 
print(my_list.sizeOfLinkedList())
my_list.insertLinkedList(65,0)
print(my_list.sizeOfLinkedList())
my_list.deleteLinkedList(7)
my_list.searchLinkedList(90)
print(my_list.sizeOfLinkedList())
print(my_list.middleLinkedList())
#my_list.reverseLinkedList()
my_list.insertAltLinkedList(112,4)
my_list.displayLinkedList()
my_list.reverseLinkedList()
#my_list.insertAltLinkedList(7,5)
'''
    