# 1. How to make a choice of random numbers in a range or given list ?

import random

# initializing list
test_list = [1, 4, 5, 2, 7]

# printing original list
print("Original list is : " + str(test_list))

# using random.choice() to
# get a random number
random_num = random.choice(test_list)

# printing random number
print("Random selected number is : " + str(random_num))

# 2. How to pass an instance to a function ?

class MyClass:
    def __init__(self, value):
        self.value = value

def function_that_takes_an_instance(instance):
    print(instance.value)

# Create an instance of MyClass
my_instance = MyClass("Hello, world!")

# Pass the instance to the function
function_that_takes_an_instance(my_instance)

# 3. How to pass a class and its args and kwargs to a function ?

class MyClass:  
    def __init__(self, *args, **kwargs): 
        self.args = args
        self.kwargs = kwargs
        # args is a tuple with the positional arguments
        # kwargs is a dictionary with the keyword arguments
        
    def display(self):
        print("Positional arguments are: ", self.args)
        print("Keyword arguments are: ", self.kwargs)

def function_that_takes_a_class(class_to_create_instance, *args, **kwargs):
    instance = class_to_create_instance(*args, **kwargs)
    instance.display()

# example 3.1
class Hello:
    def print_hello(self):
        print("Hello World from Class")
        
def external_check():
    my_instance = Hello()
    my_instance.print_hello()

external_check()

# Pass the class to the function, along with multiple values
function_that_takes_a_class(MyClass, "Hello, world!", "Another argument", key1="value1", key2="value2")

# 4. How to pass multiple instances to a function ?
class NodeT:
    def __init__(self,data):
        self.data = data
        self.next = None
        
class MyParentClass:
    def __init__(self,*args,**kwargs):
        self.args = args
        self.kwargs = kwargs
        self.h = None
        #print("I am a parent class")
        
    def createLL(self,valueT):
        n = NodeT(valueT) # creating a node is the first task.data = valueT , next = None
        if self.h is None:
            self.h = n # add this node as the head if there is no head
        else:
            t = self.h # following immutability so that head node is untouched.
            while (t.next !=None):# this is equivalent to saying while (t!=None):
                t=t.next# go to next Node
            t.next = n # finally if
            
    def displayLL(self):
        t = self.h
        if t==None:
            print("No Data")
            
        while (t!=None):
            print(t.data,end=" ")
            t=t.next
        print()
        

def function_that_takes_a_class(instance1,instance2):
    #instance = class_to_create_instance()
    #print(instance.data)
    #print(instance.next)
    instance1.displayLL()
    instance2.displayLL()
    print(instance1.h.data)
    print(instance2.h.data)

ll1 = MyParentClass()
ll2 = MyParentClass()

ll1.createLL(2)
ll1.createLL(3)
ll1.createLL(5)
ll1.createLL(10)
#ll1.displayLL()
ll2.createLL(4)
ll2.createLL(7)
ll2.createLL(14)
ll2.createLL(20)
ll2.createLL(30)
ll2.createLL(32)

# Pass the class to the function
function_that_takes_a_class(ll1,ll2)

